#!/usr/local/perl/bin/perl

### Fichier servant  gnrer une bibliographie ( partir de fichier(s) .bib)
### pour une mise en ligne. Ce programme convertit avec latex2html un
### document, en extrait la 'substantifique molle' (lignes aprs le
### 'bibliography' jusqu' '</DL>'  la fin) pour coller a dans un fichier
### '@_'.shtml comprenant notemment l'appel aux en-ttes et pieds de page
### Copyright : Thomas van Oudenhove -- 2003 - 2004 version 0.2 Thanks : Paul
### Gaborit

### Ce fichier est protg par la licence Gnu/GPL v2 de 1991 ou
### ultrieure dont le texte intgral est disponible sur
### http://www.gnu.org/licenses/gpl.html

### you should change extension .shtml with .html at your convenience ...
### just be carefull with the <!--#include -->

### WARNING : change the $entete and $piedpage variables, otherwise i'll be
### the author of your documents ;)

#packages
use warnings;
use strict;
use File::Temp qw(tempfile);
use File::Copy;

#variables
my $filename;  #the files you want to convert
my $entete;    #header of the html file
my $piedpage;  #footer of the html file
my $directory; #where you want to store the resulting file.shtml

$filename = $ARGV[0];
$directory = $ARGV[1];

die "Usage: $0 <doc_tex> <public_html directory>\n"
  if (not defined $filename) or (not defined $directory);

$entete = qq(<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">

<!--Converted with LaTeX2HTML 2002-2-1 (1.70)
original version by:  Nikos Drakos, CBLU, University of Leeds
* revised and updated by:  Marcus Hennecke, Ross Moore, Herb Swan
* with significant contributions from:
  Jens Lippmann, Marek Rouchal, Martin Wilck and others -->

<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
    <meta name="author" content="Thomas van Oudenhove">
    <meta name="Generator" CONTENT="LaTeX2HTML v2002-2-1">
    <link href="/~vanouden/monstyle.css" rel="stylesheet" type="text/css">
    <title>Bibliographie - Thomas van Oudenhove</title>
  </head>

<!--#include virtual="../entete.shtml"-->

<H2><A NAME="SECTION00010000000000000000">
Bibliographie</A>);

$piedpage = qq(
<!--#include virtual="../piedpage.shtml"-->
);

#programme
#avertissements
print ("This is bibsettler.pl v0.2 Copyright Thomas van Oudenhove 2003 \n");
print ("Settling bibliography from TeX for online publication \n");
print ("Fichier ".$filename.".tex + fichier de biblio \n");
print ("                          --> ".$filename.".shtml \n");

# compilation LaTeX pralable
system("latex", $filename);

# compilation BibTeX
system("bibtex", $filename);

# conversion LaTeX2html
system("latex2html", $filename);

#1 : ouverture du fichier node1.html
open(NODE, './'.$filename.'/node1.html') or die "Can't open node1.html";

#2 : ouvrir nomfichier.shtml
my ($BIB, $filesettled) = tempfile('bibtempXXXX',
				     SUFFIX => '.shtml');

#3 : crire l'en-tte dans nomfichier.shtml
print $BIB $entete;
my $reg_matches = "</H2><DL COMPACT><DD><P></P><DT>(<.*)";

#4 : rcuprer chaque ligne pertinente de node1.html
my $line;
my $to_write;
while (defined ($line = <NODE>) and $line !~ m/$reg_matches/){}
if ($line =~ m/$reg_matches/) {
  while (defined $line and $line ne "</DL>\n") {
      # concatner tout ce qu'il faut crire
    $to_write = $to_write.$line;
    $line = <NODE>;
  }
  $to_write = $to_write."</DL>\n";
}

#5 : crire dans nomfichier.shtml, rajouter le pied de page
print $BIB $to_write;
print $BIB $piedpage;

#6 : fin du programme
close(NODE);
close($BIB);
$filename .= ".shtml";
move($filesettled, $filename);
print ("Settling of your bibliography complete \n");
move($filename, $directory.".");
system("chmod", "644", $directory.$filename);
print ("Settling of your bibliography succeed ! \n");
print ("Check the result on your website ! \n");

__END__
